- [HTTP request](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.GroupAssetsResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#body.aspect)
- [Try it!](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/organizations.assets/group#try-it)

Filters an organization's assets and groups them by their specified properties.

### IAM Permissions

Requires the following IAM permission on the resource specified in the `parent` field:

- `securitycenter.assets.group`

### HTTP request

Choose an endpoint:
global me-central2 us eu   
`POST https://securitycenter.googleapis.com/v1beta1/{parent=organizations/*}/assets:group`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. Name of the organization to groupBy. Its format is "organizations/\[organizationId\]". |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "filter": string, "groupBy": string, "compareDuration": string, "readTime": string, "pageToken": string, "pageSize": integer } ``` |

| Fields ||
|---|---|
| `filter` | `string` Expression that defines the filter to apply across assets. The expression is a list of zero or more restrictions combined via logical operators `AND` and `OR`. Parentheses are not supported, and `OR` has higher precedence than `AND`. Restrictions have the form `<field> <operator> <value>` and may have a `-` character in front of them to indicate negation. The fields map to those defined in the Asset resource. Examples include: - name - securityCenterProperties.resource_name - resourceProperties.a_property - securityMarks.marks.marka The supported operators are: - `=` for all value types. - `>`, `<`, `>=`, `<=` for integer values. - `:`, meaning substring matching, for strings. The supported value types are: - string literals in quotes. - integer literals without quotes. - boolean literals `true` and `false` without quotes. For example, `resourceProperties.size = 100` is a valid filter string. |
| `groupBy` | `string` Required. Expression that defines what assets fields to use for grouping. The string value should follow SQL syntax: comma separated list of fields. For example: "securityCenterProperties.resource_project,securityCenterProperties.project". The following fields are supported when compareDuration is not set: - securityCenterProperties.resource_project - securityCenterProperties.resource_type - securityCenterProperties.resource_parent The following fields are supported when compareDuration is set: - securityCenterProperties.resource_type |
| `compareDuration` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#duration` format)`` When compareDuration is set, the Asset's "state" property is updated to indicate whether the asset was added, removed, or remained present during the compareDuration period of time that precedes the readTime. This is the time between (readTime - compareDuration) and readTime. The state value is derived based on the presence of the asset at the two points in time. Intermediate state changes between the two times don't affect the result. For example, the results aren't affected if the asset is removed and re-created again. Possible "state" values when compareDuration is specified: - "ADDED": indicates that the asset was not present before compareDuration, but present at reference_time. - "REMOVED": indicates that the asset was present at the start of compareDuration, but not present at reference_time. - "ACTIVE": indicates that the asset was present at both the start and the end of the time period defined by compareDuration and reference_time. This field is ignored if `state` is not a field in `groupBy`. A duration in seconds with up to nine fractional digits, ending with '`s`'. Example: `"3.5s"`. |
| `readTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Time used as a reference point when filtering assets. The filter is limited to assets existing at the supplied time and their values are those at that specific time. Absence of this field will default to the API's version of NOW. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `pageToken` | `string` The value returned by the last `GroupAssetsResponse`; indicates that this is a continuation of a prior `assets.group` call, and that the system should return the next page of data. |
| `pageSize` | `integer` The maximum number of results to return in a single response. Default is 10, minimum is 1, maximum is 1000. |

### Response body

Response message for grouping by assets.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "groupByResults": [ { object (`https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/GroupResult`) } ], "readTime": string, "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `groupByResults[]` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1beta1/GroupResult`)`` Group results. There exists an element for each existing unique combination of property/values. The element contains a count for the number of times those specific property/values appear. |
| `readTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Time used for executing the groupBy request. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `nextPageToken` | `string` Token to retrieve the next page of results, or empty if there are no more results. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/securitycenter`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).